; printf.asm    print an integer from storage and from a register
; Assemble:     nasm -f elf printf.asm
; Link:         gcc -m32 -o printf  printf.o
; Run:          printf
; Output:       a=5, eax=7

; Equivalent C code
; int a = 5;
; int main() {
;   printf("a=%d, eax=%d\n", a, a+2);
;   return 0;
; }

; Declare some external functions
;
extern    printf        ; the C function, to be called

section .data        ; Data section, initialized variables
    a:   dd 5        ; int a=5;
    fmt: db "a=%d, eax=%d", 10, 0 ; The printf format, "\n",'0'

section .text        ; Code section.
    global main ; the standard gcc entry point

main:                  ; the program label for the entry point
    push ebp           ; set up stack frame
    mov  ebp, esp

    ; third parameter: a+2
    mov  eax, [a]     ; put a from store into register
    add  eax, 2       ; a+2
    push eax          ; value of a+2
    
    ; second parameter: a
    push dword [a]    ; value of variable a
    
    ; third parameter: formatting string
    push dword fmt    ; address of ctrl string
    
    call printf       ; Call C function
    add  esp, 12      ; release parameters: 3 * 4 bytes

    mov  eax, 0       ; normal, no error, return value
    leave             ; takedown stack frame
    ret               ; return
    
